##################################
### MsgLog.tcl                 ###
### Version 1.1                ###
### By Wcc                     ###
### wcc@techmonkeys.org        ###
### http://www.dawgtcl.com:81/ ###
### EFnet #|DAWG|Tcl           ###
##################################

############################################################################
### Copyright  2000 - 2002 |DAWG| Scripting Group. All rights reserved. ###
############################################################################

###########################################################
## This logs all messages sent to the bot to a web page. ##
###########################################################

##########################################################
## Just load the script, edit the settings, and rehash. ##
##########################################################

#######################################################################
# Set here the path to the DAWG template file you would like to use.  #
# You can obtain templates by visiting http://www.dawgtcl.com:81/ and #
# clicking the templates link.                                        #
#######################################################################

set msglog_setting(tpl) "./scripts/MsgLog_DAWG.tpl"

##############################
# Set the text logfile here. #
##############################

set msglog_setting(log) "./scripts/msg.log"

###################################
# Show userhosts on the web page? #
###################################

set msglog_setting(uhost) 0

##########################################################################
# Set the max number of lines to post on the web page here (latest lines #
# shown).                                                                #
##########################################################################

set msglog_setting(maxlines) "200"

###############################
# Set the HTML filename here. #
###############################

set msglog_setting(page) "../WEBROOT/msgs.html"

#############################################################################
# Items in this list will be ignored from logging. Wildcards are supported. #
# These must be lower case.                                                 #
#############################################################################

set msglog_setting(ignore) {
	"pass*" "ident*" "addhost*" "notes*" "info*" "who*" "help*" "voice*"
	"whois*" "hello*" "op*" "invite*" "go*" "key*" "die*" "jump*" "memory*"
	"save*" "rehash*" "reset*" "status*"
}

#############################################################################
# Set the flood limit here. This will prevent the bot from being overloaded #
# the event of a message flood. Format: <msgs>:<time>.                      #
#############################################################################

set msglog_setting(flood) "8:3"

####################
# Code begins here #
####################

if {![string match 1.6.* $version]} { putlog "\002MSGLOG:\002 \002WARNING:\002 This script is intended to run on eggdrop 1.6.x." }
if {[info tclversion] < 8.2} { putlog "\002MSGLOG:\002 \002WARNING:\002 This script is intended to run on Tcl Version 8.2 or later." }

bind raw - PRIVMSG msglog_filt

foreach {a b} [list msglog_setting(version) "1.1" msglog_notpl 0 msglog_setting(f_mc) 0] { set $a $b }
regexp {^([0-9]+):([0-9]+)$} $msglog_setting(flood) msglog_tmpmatch msglog_setting(f_msgs) msglog_setting(f_time)
if {![info exists msglog_setting(tpl)] || [catch {source $msglog_setting(tpl)}]} { putlog "\002MSGLOG:\002 The template file could not be opened; using default." ; set msglog_notpl 1 }
if {[lsearch -glob [utimers] "* msglog_flood *"] == -1} { utimer $msglog_setting(f_time) msglog_flood }
foreach {s v} [list Page_CC "#000000" Page_HC "#000000" Page_LinkC "#0000FF" Page_TTextC "#000000" Page_TextC "#000000" Page_BGC "#FFFFFF" \
	Page_TCC_2 "#E0E0E0" Page_TCC_1 "#C0C0C0" Page_THC_2 "#8080E0" Page_THC_1 "#8080C0" Page_TCS "4" Page_THS "5" Page_TitleS "6" \
	Page_Title {Private Message Log} Page_TitleTag {Private Message Log} Page_Img {}] {
	if {$msglog_notpl || ![info exists msglog_setting($s)]} { set msglog_setting($s) $v  }
}

proc msglog_format_td {type line center text} {
	switch -- $type {
		"title" { return "<font size=\"$::msglog_setting(Page_THS)\" color=\"$::msglog_setting(Page_TextC)\">[expr {($center) ? "<center>" : ""}]$text[expr {($center) ? "</center>" : ""}]</font>" }
		"header" { return "<td align=\"left\" bgcolor=\"$::msglog_setting(Page_THC_${line})\"><font size=\"$::msglog_setting(Page_THS)\" color=\"$::msglog_setting(Page_HC)\">[expr {($center) ? "<center>" : ""}]$text[expr {($center) ? "</center>" : ""}]</font></td>" }
		"cell" { return "<td align=\"left\" bgcolor=\"$::msglog_setting(Page_TCC_${line})\"><font size=\"$::msglog_setting(Page_TCS)\" color=\"$::msglog_setting(Page_CC)\">[expr {($center) ? "<center>" : ""}]$text[expr {($center) ? "</center>" : ""}]</font></td>" }
	}
}
proc msglog_filt {from keyword text} {
	if {$::msglog_setting(f_mc) > $::msglog_setting(f_msgs)} { return }
	foreach {s v} [list chan [join [lrange [split $text] 0 0]] text [string trimleft [join [lrange [split $text] 1 end]] :] nick [join [lrange [split $from !] 0 0]] uhost [join [lrange [split $from !] 1 1]]] { set $s $v }
	set hand [expr {([regexp {^(\*|())$} [nick2hand $nick]]) ? "" : "[nick2hand $nick]"}]
	if {[regexp "\001" $text] || ![isbotnick $chan]} { return }
	foreach a $::msglog_setting(ignore) {
		if {[string match $a [string tolower $text]]} { return }
	}
	msglog_addlog [list [clock seconds] $nick $uhost $text]
	incr ::msglog_setting(f_msgs)
	return
}
proc msglog_addlog {text} {
	set fd [open $::msglog_setting(log) a+]
	puts $fd [join $text]
	close $fd
	msglog_html
}
proc msglog_flood {} {
	if {[lsearch -glob [utimers] "* msglog_flood *"] == -1} { utimer $::msglog_setting(f_time) msglog_flood }
	set ::msglog_setting(f_mc) 0
}
proc msglog_html {} {
	foreach {a b} [list page [open $::msglog_setting(page) w] msgctr 0] { set $a $b }
	puts $page "<html>\n  <head>\n    <title>$::msglog_setting(Page_TitleTag)</title>\n    <META NAME=\"description\" CONTENT=\"Private Message Log\">\n    <META NAME=\"keywords\" CONTENT=\"privmsg, msg, log, irc, message\">\n  </head>\n\n  <body bgcolor=\"$::msglog_setting(Page_BGC)\" link=\"$::msglog_setting(Page_LinkC)\" alink=\"$::msglog_setting(Page_LinkC)\" vlink=\"$::msglog_setting(Page_LinkC)\">"
	if {[string compare $::msglog_setting(Page_Img) ""] != 0} { puts $page "    <center><img src=\"$::msglog_setting(Page_Img)\"></img></center>" }
	puts $page "    <center><font size=\"$::msglog_setting(Page_TitleS)\" color=\"$::msglog_setting(Page_TTextC)\">$::msglog_setting(Page_Title)</font></center>\n    <br>"
	puts $page "    <br>\n    <br>\n    [msglog_format_td title 0 1 {Private Messages}]\n    <br>\n    <table align=\"center\">\n      <tr>"
	if {![set error [catch {open $::msglog_setting(log) r} logfd]]} {
		set data [split [read $logfd] "\n"]
		set data [lrange $data [expr [llength $data] - (1 + $::msglog_setting(maxlines))] end]
		close $logfd
	}
	foreach {a b} [list 1 Number 2 Time 1 Nick 2 Host 1 Message] { puts $page "        [msglog_format_td header $a 1 $b]" }
	if {$error} {
		puts $page "      <tr>"
		foreach {a b c} [list 1 1 1 2 1 [clock format [clock seconds] -format "%D %I:%M %p"] 1 1 - 2 1 - 2 0 [expr {([file exists $::msglog_setting(log)]) ? "The log database could not be opened." : "The log database does not exist."}]] { puts $page "        [msglog_format_td cell $a $b $c]" }
		puts $page "      </tr>"
	} {
		foreach line $data {
			if {[string length $line] < 2} { continue }
			set line [split $line]
			puts $page "      <tr>"
			foreach {a b c} [list 1 1 [incr msgctr] 2 1 [clock format [lindex $line 0] -format "%D %I:%M %p"] 1 1 [join [lrange $line 1 1]] 2 1 [expr {($::msglog_setting(uhost)) ? "[join [lrange $line 2 2]]" : "-"}] 1 0 [join [lrange $line 3 end]]] { puts $page "        [msglog_format_td cell $a $b $c]" }
			puts $page "      </tr>"
		}
	}
	puts $page "    </table>\n    <br>\n    <br>"
	puts $page "    <center><font color=\"$::msglog_setting(Page_TextC)\">Last Updated: [clock format [clock seconds] -format "%D %I:%M %p"]</font></center>\n    <center><font color=\"$::msglog_setting(Page_TextC)\">Generated By: $::botnick</font></center>\n  </body>\n</html>\n<!--<DAWGID>MsgLog $::msglog_setting(version)</DAWGID>-->"
	close $page
}

putlog "\002MSGLOG:\002 MsgLog.tcl Version $msglog_setting(version) by Wcc is loaded."
